Bug 1466452 - Documentation: The check for differences between the default T-H-T templates and the custom ones should be performed before upgrading the undercloud.
Documentation: The check for differences between the default T-H-T templates ...
Status: ASSIGNED
Product: Red Hat OpenStack
Classification: Red Hat
Component: documentation (Show other bugs)
10.0 (Newton)
Unspecified Unspecified
unspecified Severity unspecified
: async
: 10.0 (Newton)
Assigned To: Dan Macpherson
RHOS Documentation Team
: Triaged, ZStream
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2017-06-29 12:09 EDT by Alexander Chuzhoy
Modified: 2017-07-17 07:22 EDT (History)
5 users (show)

See Also:
Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed:
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Alexander Chuzhoy 2017-06-29 12:09:49 EDT
Documentation: The check for differences between the default T-H-T templates and the custom ones should be performed before upgrading the undercloud.

At the end of section 3.2 here:
https://access.redhat.com/documentation/en-us/red_hat_openstack_platform/10/html/upgrading_red_hat_openstack_platform/chap-upgrading_the_environment#sect-Major-Updating_Director_Packages


There's a note:
"
Important

If using customized core Heat templates, make sure to check for differences between the updated core Heat templates and your current set. Red Hat provides updates to the Heat template collection over subsequent releases. Using a modified template collection can lead to a divergence between your custom copy and the original copy in /usr/share/openstack-tripleo-heat-templates. Run the following command to see differences between your custom Heat template collection and the updated original version:

# diff -Nar /usr/share/openstack-tripleo-heat-templates/ ~/templates/my-overcloud/

Make sure to either apply these updates to your custom Heat template collection, or create a new copy of the templates in /usr/share/openstack-tripleo-heat-templates/ and apply your customizations. 
"


The thing is that this note comes after the undercloud is updated, which also includes updating the THT templates in their default location. 
We need to make sure that the comparison is done before.
Comment 1 Alexander Chuzhoy 2017-06-29 12:25:20 EDT
Seems like section 3.4.2 in the same url  should move to the top. Before starting the undercloud upgrade.
Comment 2 Sofer Athlan-Guyot 2017-06-30 11:33:34 EDT
Hi Sasha,

not sure, as if you don't upgrade the undercloud you don't have new upgrade t-h-t.   I may be missing something here.   I think you need to compare at two spots:
 - during upgrade: after the undercloud upgrade;
 - during update: after the undercloud update;

but before undercloud upgrade, I don't see it.
Comment 3 Alexander Chuzhoy 2017-06-30 12:29:49 EDT
Hi Sofer,
So from the eyes of a person performing an upgrade on a setup he didn't deploy:

if you had customization (basically a local copy of templates manually modified with the changes specific to the setup) - you might want to identify what they are prior to updating the THT templates, because after the templates are updated - it's tough to understand whether the difference came from the update or due to manual customization.
Makes sense?
Comment 4 Alexander Chuzhoy 2017-06-30 12:31:20 EDT
Sofer,
You need to identify the customized stuff, so that it can be re-applied on the updated templates.
Comment 5 Sofer Athlan-Guyot 2017-07-04 05:00:40 EDT
Hum... well, make sense.

So it would something more like:

"Before upgrading your undercloud, you need to make sure you have identified all the templates you're using.   If some are the default one in /usr/share/openstack-tripleo-heat-templates, back them up, if there are *all* in a custom location (as advised in the advanced template guide[1]) then you are safe"

Is that describing what you've got in mind Sasha ?


[1] Dan, I don't remember the exact link...
Comment 6 Alexander Chuzhoy 2017-07-04 10:29:33 EDT
With the following BUG in mind, using templates from different paths is a bad idea to begin with:
https://bugzilla.redhat.com/show_bug.cgi?id=1465567


What I have in mind is:
Let's say for example that you use a set of local templates "~/templates" (basically a copy of /usr/share/openstack-tripleo-heat-templates directory).

Now, you customize the templates under "~/templates".

If you run diff now - you can see the changes (and only the changes) that you did to the local copy.

Now, If you update the THT package, then the templates under /usr/share/openstack-tripleo-heat-templates directory become updated/different and running diff won't be as much of a help - you'll see many differences and at this point it will become harder to identify what customization needs to be applied to the updated templates (after you copy them to ~/templates).

Hence, the difference between the local set of templates (~/templates) and the default location (/usr/share/openstack-tripleo-heat-templates directory) needs to be identified prior to upgrading the undercloud.
Comment 7 Dan Macpherson 2017-07-06 09:31:25 EDT
Hi guys,

I'm in the process of backporting the git instructions from OSP11. I think this might be the best way to check and manage differences between the template versions.

I've already discussed this with Sasha last week, but Sofer, did you have any thoughts on this?
Comment 8 Sofer Athlan-Guyot 2017-07-17 07:22:05 EDT
Hi Dan,

the Sasha's proposal make sense, go for it :)

Thanks,

Note You need to log in before you can comment on or make changes to this bug.